# Input validation works correctly

    Code
      calculate_mme(x = test_data, id_col = "missing_column")
    Condition
      Error in `calculate_mme()`:
      ! `id_col` column "missing_column" not found in `x`

---

    Code
      calculate_mme(x = bad_data)
    Condition
      Error in `calculate_mme()`:
      ! bad_data is missing required columns: "medication_name"

---

    Code
      calculate_mme(x = bad_data2, therapy_days_without_col = "therapy_days_without")
    Condition
      Error in `calculate_mme()`:
      ! bad_data2 is missing required columns: "therapy_days_without"

---

    Code
      calculate_mme(x = output)
    Condition
      Error in `calculate_mme.list()`:
      ! argument "therapy_days" is missing, with no default

# Custom column names are handled correctly

    Code
      result
    Output
      $medications
      # A tibble: 235 x 12
         subject_id med_name         dosage doses_daily duration_days therapy_duration
         <chr>      <chr>             <dbl>       <dbl>         <dbl>            <dbl>
       1 P001       Fentanyl patch ~   12.5           1             7                7
       2 P001       tramadol (mg) LA  125             1            30               30
       3 P002       Hydrocodone (mg)   10             3            14               14
       4 P002       tramadol (mg)      60             3            14               14
       5 P003       Meperidine HCL ~   50             4             7                7
       6 P003       tramadol (mg)      90             3             7                7
       7 P003       Opium (mg)         40             3            14               14
       8 P003       Hydrocodone (mg)    5             2             3                3
       9 P004       Hydrocodone (mg)   10             3             7                7
      10 P005       Codeine (mg)       45             1             7                7
      # i 225 more rows
      # i 6 more variables: observation_period <dbl>, therapy_wo_bup <dbl>,
      #   observation_wo_bup <dbl>, factor <dbl>, mme <dbl>, single_day_mme <dbl>
      
      $patient_summary_with_buprenorphine
          subject_id therapy_days observation_window_days total_mme total_days
      1         P001            7                      30    960.00         37
      2         P002           14                      30    924.00         28
      3         P003            7                      30   2228.00         31
      4         P004            7                      30    210.00          7
      5         P005            7                      30     47.25          7
      6         P006            7                      30   3395.25         31
      7         P007            5                      30     50.00          5
      8         P008            7                      30   3136.00          7
      9         P009            3                      30    108.00          3
      10        P010           28                      42   5040.00         28
      11        P011            7                      30   2362.50         14
      12        P012           10                      30   1345.00         31
      13        P013            3                      30  17853.75         80
      14        P014           30                      45  13207.50        120
      15        P015            7                      30     57.75          7
      16        P016           10                      30   1195.50         20
      17        P017           10                      30   1826.50         54
      18        P018           14                      30    378.00         14
      19        P019           14                      30   2016.00         14
      20        P020           30                      45   3030.00         40
      21        P021           10                      30   1099.50         41
      22        P022           28                      42   1160.00         38
      23        P023            3                      30    270.00          3
      24        P024           30                      45  15360.00         30
      25        P025            5                      30  10005.00         65
      26        P026            7                      30   7276.50         84
      27        P027            7                      30    315.00          7
      28        P028           10                      30    742.00         18
      29        P029            5                      30    960.00          5
      30        P030           10                      30    140.00         10
      31        P031           14                      30   6172.50        134
      32        P032           30                      45   5332.50         37
      33        P033           10                      30   1002.00         24
      34        P034           10                      30    795.00         24
      35        P035            7                      30   1170.00         27
      36        P036            3                      30    450.00         10
      37        P037            3                      30    410.00         10
      38        P038           14                      30   2785.00         58
      39        P039           10                      30   1325.00         28
      40        P040           10                      30   2300.00         40
      41        P041            7                      30   1002.50         43
      42        P042           10                      30    499.50         10
      43        P043           30                      45   1110.00         40
      44        P044            7                      30   1637.25         22
      45        P045           30                      45    885.00         42
      46        P046           90                     135   8194.50         97
      47        P047           30                      45   2460.00         44
      48        P048           10                      30     80.00         10
      49        P049           30                      45    765.00         60
      50        P050            7                      30   1075.00         45
      51        P051           10                      30   1020.50         24
      52        P052            7                      30    105.00          7
      53        P053           10                      30   1183.50         47
      54        P054           30                      45   2107.50         50
      55        P055           28                      42   3125.00         68
      56        P056           30                      45   1023.75         35
      57        P057           14                      30     52.50         14
      58        P058           14                      30  10037.50         31
      59        P059           14                      30   2040.00         54
      60        P060            3                      30    285.00         10
      61        P061            3                      30    450.00          3
      62        P062            5                      30    630.00         25
      63        P063           10                      30    225.00         10
      64        P064            3                      30     49.50          3
      65        P065           30                      45   1944.75         50
      66        P066            7                      30    462.00          7
      67        P067           30                      45  12312.75         84
      68        P068            5                      30   1850.00         19
      69        P069           10                      30    688.50         17
      70        P070           10                      30   1900.00         70
      71        P071            7                      30   4865.00         44
      72        P072           14                      30   1691.00         59
      73        P073            7                      30  21200.00         88
      74        P074            7                      30   1510.00         37
      75        P075            3                      30    405.00          3
      76        P076           30                      45   8304.00        104
      77        P077            5                      30    504.75         15
      78        P078           10                      30   1007.00         27
      79        P079           10                      30   3899.00         24
      80        P080           10                      30   1840.00         30
      81        P081           10                      30    607.50         17
      82        P082            3                      30   1338.00         20
      83        P083           30                      45   4720.00         40
      84        P084           14                      30   1232.50         24
      85        P085            5                      30   1537.50         45
      86        P086           14                      30   9450.00         14
      87        P087            7                      30   3544.00         87
      88        P088           10                      30   2122.50         50
      89        P089           14                      30  14464.60         31
      90        P090            7                      30    155.25         10
      91        P091            3                      30    877.50         27
      92        P092           30                      45   1363.50         47
      93        P093            7                      30    262.50          7
      94        P094            5                      30   1464.50         36
      95        P095            7                      30    350.00          7
      96        P096           10                      30   1000.00         10
      97        P097            7                      30  20082.00         40
      98        P098            7                      30    840.00          7
      99        P099           90                     135   6038.50        130
      100       P100            5                      30     90.00          5
               mme1       mme2       mme3     mme4
      1    25.94595  137.14286  32.000000   55.000
      2    33.00000   66.00000  30.800000   66.000
      3    71.87097  318.28571  74.266667  204.000
      4    30.00000   30.00000   7.000000   30.000
      5     6.75000    6.75000   1.575000    6.750
      6   109.52419  485.03571 113.175000  393.750
      7    10.00000   10.00000   1.666667   10.000
      8   448.00000  448.00000 104.533333  448.000
      9    36.00000   36.00000   3.600000   36.000
      10  180.00000  180.00000 120.000000  180.000
      11  168.75000  337.50000  78.750000  337.500
      12   43.38710  134.50000  44.833333  130.000
      13  223.17188 5951.25000 595.125000  405.250
      14  110.06250  440.25000 293.500000  160.250
      15    8.25000    8.25000   1.925000    8.250
      16   59.77500  119.55000  39.850000  119.550
      17   33.82407  182.65000  60.883333   87.350
      18   27.00000   27.00000  12.600000   27.000
      19  144.00000  144.00000  67.200000  144.000
      20   75.75000  101.00000  67.333333  123.000
      21   26.81707  109.95000  36.650000  100.750
      22   30.52632   41.42857  27.619048   80.000
      23   90.00000   90.00000   9.000000   90.000
      24  512.00000  512.00000 341.333333  512.000
      25  153.92308 2001.00000 333.500000  186.000
      26   86.62500 1039.50000 242.550000  333.000
      27   45.00000   45.00000  10.500000   45.000
      28   41.22222   74.20000  24.733333  114.000
      29  192.00000  192.00000  32.000000  192.000
      30   14.00000   14.00000   4.666667   14.000
      31   46.06343  440.89286 205.750000  283.250
      32  144.12162  177.75000 118.500000  229.500
      33   41.75000  100.20000  33.400000  133.500
      34   33.12500   79.50000  26.500000   67.500
      35   43.33333  167.14286  39.000000  129.000
      36   45.00000  150.00000  15.000000   70.000
      37   41.00000  136.66667  13.666667  110.000
      38   48.01724  198.92857  92.833333  183.500
      39   47.32143  132.50000  44.166667  178.500
      40   57.50000  230.00000  76.666667  110.000
      41   23.31395  143.21429  33.416667  110.000
      42   49.95000   49.95000  16.650000   49.950
      43   27.75000   37.00000  24.666667   51.000
      44   74.42045  233.89286  54.575000  188.250
      45   21.07143   29.50000  19.666667  108.750
      46   84.47938   91.05000  60.700000  103.500
      47   55.90909   82.00000  54.666667   90.000
      48    8.00000    8.00000   2.666667    8.000
      49   12.75000   25.50000  17.000000   25.500
      50   23.88889  153.57143  35.833333   71.500
      51   42.52083  102.05000  34.016667   95.750
      52   15.00000   15.00000   3.500000   15.000
      53   25.18085  118.35000  39.450000   65.500
      54   42.15000   70.25000  46.833333  180.750
      55   45.95588  111.60714  74.404762  116.500
      56   29.25000   34.12500  22.750000   54.750
      57    3.75000    3.75000   1.750000    3.750
      58  323.79032  716.96429 334.583333  972.100
      59   37.77778  145.71429  68.000000  126.000
      60   28.50000   95.00000   9.500000   75.000
      61  150.00000  150.00000  15.000000  150.000
      62   25.20000  126.00000  21.000000   78.000
      63   22.50000   22.50000   7.500000   22.500
      64   16.50000   16.50000   1.650000   16.500
      65   38.89500   64.82500  43.216667  212.575
      66   66.00000   66.00000  15.400000   66.000
      67  146.58036  410.42500 273.616667  487.250
      68   97.36842  370.00000  61.666667  290.000
      69   40.50000   68.85000  22.950000   87.750
      70   27.14286  190.00000  63.333333   40.000
      71  110.56818  695.00000 162.166667  235.000
      72   28.66102  120.78571  56.366667  139.000
      73  240.90909 3028.57143 706.666667  470.000
      74   40.81081  215.71429  50.333333   58.000
      75  135.00000  135.00000  13.500000  135.000
      76   79.84615  276.80000 184.533333  356.000
      77   33.65000  100.95000  16.825000   80.475
      78   37.29630  100.70000  33.566667  108.800
      79  162.45833  389.90000 129.966667  416.000
      80   61.33333  184.00000  61.333333  184.000
      81   35.73529   60.75000  20.250000   67.500
      82   66.90000  446.00000  44.600000  266.000
      83  118.00000  157.33333 104.888889  184.000
      84   51.35417   88.03571  41.083333  107.500
      85   34.16667  307.50000  51.250000  182.500
      86  675.00000  675.00000 315.000000  675.000
      87   40.73563  506.28571 118.133333  217.000
      88   42.45000  212.25000  70.750000   92.250
      89  466.60000 1033.18571 482.153333 2032.100
      90   15.52500   22.17857   5.175000   42.750
      91   32.50000  292.50000  29.250000  183.750
      92   29.01064   45.45000  30.300000  128.850
      93   37.50000   37.50000   8.750000   37.500
      94   40.68056  292.90000  48.816667  221.750
      95   50.00000   50.00000  11.666667   50.000
      96  100.00000  100.00000  33.333333  100.000
      97  502.05000 2868.85714 669.400000  724.000
      98  120.00000  120.00000  28.000000  120.000
      99   46.45000   67.09444  44.729630  123.500
      100  18.00000   18.00000   3.000000   18.000
      
      $patient_summary_without_buprenorphine
          subject_id therapy_days observation_window_days total_mme total_days
      1         P001            7                      30    960.00         37
      2         P002           14                      30    924.00         28
      3         P003            7                      30   2228.00         31
      4         P004            7                      30    210.00          7
      5         P005            7                      30     47.25          7
      6         P006            7                      30   3395.25         31
      7         P007            5                      30     50.00          5
      8         P008            7                      30   3136.00          7
      9         P009            3                      30    108.00          3
      10        P010           28                      42   5040.00         28
      11        P011            7                      30   2362.50         14
      12        P012           10                      30   1345.00         31
      13        P013            3                      30  17853.75         80
      14        P014           30                      45  13207.50        120
      15        P015            7                      30     57.75          7
      16        P016            6                      29    630.00         10
      17        P017           10                      30   1826.50         54
      18        P018           14                      30    378.00         14
      19        P019           14                      30   2016.00         14
      20        P020           30                      45   3030.00         40
      21        P021           10                      30   1099.50         41
      22        P022           28                      42   1160.00         38
      23        P023            3                      30    270.00          3
      24        P024           30                      45  15360.00         30
      25        P025            5                      30  10005.00         65
      26        P026            7                      30   7276.50         84
      27        P027            7                      30    315.00          7
      28        P028           10                      30    742.00         18
      29        P029            5                      30    960.00          5
      30        P030           10                      30    140.00         10
      31        P031           14                      30   6172.50        134
      32        P032           30                      45   5332.50         37
      33        P033           10                      30   1002.00         24
      34        P034           10                      30    795.00         24
      35        P035            7                      30   1170.00         27
      36        P036            3                      30    450.00         10
      37        P037            3                      30    410.00         10
      38        P038           14                      30   2785.00         58
      39        P039           10                      30   1325.00         28
      40        P040           10                      30   2300.00         40
      41        P041            5                      28    617.50         29
      42        P042           10                      30    499.50         10
      43        P043           30                      45   1110.00         40
      44        P044            7                      30   1637.25         22
      45        P045           30                      45    885.00         42
      46        P046           90                     135   8194.50         97
      47        P047           30                      45   2460.00         44
      48        P048           10                      30     80.00         10
      49        P049           26                      41    270.00         30
      50        P050            7                      30   1075.00         45
      51        P051           10                      30   1020.50         24
      52        P052            7                      30    105.00          7
      53        P053           10                      30   1183.50         47
      54        P054           30                      45   2107.50         50
      55        P055           28                      42   3125.00         68
      56        P056           30                      45   1023.75         35
      57        P057           14                      30     52.50         14
      58        P058           11                      23   1501.50         21
      59        P059           14                      30   2040.00         54
      60        P060            3                      30    285.00         10
      61        P061            3                      30    450.00          3
      62        P062            5                      30    630.00         25
      63        P063           10                      30    225.00         10
      64        P064            3                      30     49.50          3
      65        P065           26                      39   1096.50         40
      66        P066            7                      30    462.00          7
      67        P067           30                      45  12312.75         84
      68        P068            5                      30   1850.00         19
      69        P069           10                      30    688.50         17
      70        P070           10                      30   1900.00         70
      71        P071            7                      30   4865.00         44
      72        P072           14                      30   1691.00         59
      73        P073            7                      30  21200.00         88
      74        P074            7                      30   1510.00         37
      75        P075            3                      30    405.00          3
      76        P076           30                      45   8304.00        104
      77        P077            3                      20    300.00          5
      78        P078           10                      30   1007.00         27
      79        P079           10                      30   3899.00         24
      80        P080           10                      30   1840.00         30
      81        P081           10                      30    607.50         17
      82        P082            3                      30   1338.00         20
      83        P083           30                      45   4720.00         40
      84        P084           14                      30   1232.50         24
      85        P085            1                      29   1050.00         40
      86        P086           14                      30   9450.00         14
      87        P087            7                      30   3544.00         87
      88        P088           10                      30   2122.50         50
      89        P089           10                      23    613.00         24
      90        P090            7                      30    155.25         10
      91        P091            3                      30    877.50         27
      92        P092           30                      45   1363.50         47
      93        P093            7                      30    262.50          7
      94        P094            5                      30   1464.50         36
      95        P095            7                      30    350.00          7
      96        P096           10                      30   1000.00         10
      97        P097            7                      30  20082.00         40
      98        P098            7                      30    840.00          7
      99        P099           90                     135   6038.50        130
      100       P100            5                      30     90.00          5
               mme1       mme2       mme3   mme4
      1    25.94595  137.14286  32.000000  55.00
      2    33.00000   66.00000  30.800000  66.00
      3    71.87097  318.28571  74.266667 204.00
      4    30.00000   30.00000   7.000000  30.00
      5     6.75000    6.75000   1.575000   6.75
      6   109.52419  485.03571 113.175000 393.75
      7    10.00000   10.00000   1.666667  10.00
      8   448.00000  448.00000 104.533333 448.00
      9    36.00000   36.00000   3.600000  36.00
      10  180.00000  180.00000 120.000000 180.00
      11  168.75000  337.50000  78.750000 337.50
      12   43.38710  134.50000  44.833333 130.00
      13  223.17188 5951.25000 595.125000 405.25
      14  110.06250  440.25000 293.500000 160.25
      15    8.25000    8.25000   1.925000   8.25
      16   63.00000  105.00000  21.724138  63.00
      17   33.82407  182.65000  60.883333  87.35
      18   27.00000   27.00000  12.600000  27.00
      19  144.00000  144.00000  67.200000 144.00
      20   75.75000  101.00000  67.333333 123.00
      21   26.81707  109.95000  36.650000 100.75
      22   30.52632   41.42857  27.619048  80.00
      23   90.00000   90.00000   9.000000  90.00
      24  512.00000  512.00000 341.333333 512.00
      25  153.92308 2001.00000 333.500000 186.00
      26   86.62500 1039.50000 242.550000 333.00
      27   45.00000   45.00000  10.500000  45.00
      28   41.22222   74.20000  24.733333 114.00
      29  192.00000  192.00000  32.000000 192.00
      30   14.00000   14.00000   4.666667  14.00
      31   46.06343  440.89286 205.750000 283.25
      32  144.12162  177.75000 118.500000 229.50
      33   41.75000  100.20000  33.400000 133.50
      34   33.12500   79.50000  26.500000  67.50
      35   43.33333  167.14286  39.000000 129.00
      36   45.00000  150.00000  15.000000  70.00
      37   41.00000  136.66667  13.666667 110.00
      38   48.01724  198.92857  92.833333 183.50
      39   47.32143  132.50000  44.166667 178.50
      40   57.50000  230.00000  76.666667 110.00
      41   21.29310  123.50000  22.053571  82.50
      42   49.95000   49.95000  16.650000  49.95
      43   27.75000   37.00000  24.666667  51.00
      44   74.42045  233.89286  54.575000 188.25
      45   21.07143   29.50000  19.666667 108.75
      46   84.47938   91.05000  60.700000 103.50
      47   55.90909   82.00000  54.666667  90.00
      48    8.00000    8.00000   2.666667   8.00
      49    9.00000   10.38462   6.585366   9.00
      50   23.88889  153.57143  35.833333  71.50
      51   42.52083  102.05000  34.016667  95.75
      52   15.00000   15.00000   3.500000  15.00
      53   25.18085  118.35000  39.450000  65.50
      54   42.15000   70.25000  46.833333 180.75
      55   45.95588  111.60714  74.404762 116.50
      56   29.25000   34.12500  22.750000  54.75
      57    3.75000    3.75000   1.750000   3.75
      58   71.50000  136.50000  65.282609 118.50
      59   37.77778  145.71429  68.000000 126.00
      60   28.50000   95.00000   9.500000  75.00
      61  150.00000  150.00000  15.000000 150.00
      62   25.20000  126.00000  21.000000  78.00
      63   22.50000   22.50000   7.500000  22.50
      64   16.50000   16.50000   1.650000  16.50
      65   27.41250   42.17308  28.115385 127.75
      66   66.00000   66.00000  15.400000  66.00
      67  146.58036  410.42500 273.616667 487.25
      68   97.36842  370.00000  61.666667 290.00
      69   40.50000   68.85000  22.950000  87.75
      70   27.14286  190.00000  63.333333  40.00
      71  110.56818  695.00000 162.166667 235.00
      72   28.66102  120.78571  56.366667 139.00
      73  240.90909 3028.57143 706.666667 470.00
      74   40.81081  215.71429  50.333333  58.00
      75  135.00000  135.00000  13.500000 135.00
      76   79.84615  276.80000 184.533333 356.00
      77   60.00000  100.00000  15.000000  60.00
      78   37.29630  100.70000  33.566667 108.80
      79  162.45833  389.90000 129.966667 416.00
      80   61.33333  184.00000  61.333333 184.00
      81   35.73529   60.75000  20.250000  67.50
      82   66.90000  446.00000  44.600000 266.00
      83  118.00000  157.33333 104.888889 184.00
      84   51.35417   88.03571  41.083333 107.50
      85   26.25000 1050.00000  36.206897  85.00
      86  675.00000  675.00000 315.000000 675.00
      87   40.73563  506.28571 118.133333 217.00
      88   42.45000  212.25000  70.750000  92.25
      89   25.54167   61.30000  26.652174  53.30
      90   15.52500   22.17857   5.175000  42.75
      91   32.50000  292.50000  29.250000 183.75
      92   29.01064   45.45000  30.300000 128.85
      93   37.50000   37.50000   8.750000  37.50
      94   40.68056  292.90000  48.816667 221.75
      95   50.00000   50.00000  11.666667  50.00
      96  100.00000  100.00000  33.333333 100.00
      97  502.05000 2868.85714 669.400000 724.00
      98  120.00000  120.00000  28.000000 120.00
      99   46.45000   67.09444  44.729630 123.50
      100  18.00000   18.00000   3.000000  18.00
      

# Empty results are handled correctly

    Code
      calculate_mme(x = test_data)
    Condition
      Error in `calculate_mme()`:
      ! `x` must contian at least one row of data

